Bug 608608 - rpm doesn't correctly checks multiple signatures with the same key, but different hash algorithms
rpm doesn't correctly checks multiple signatures with the same key, but diffe...
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 6
Classification: Red Hat
Component: rpm (Show other bugs)
6.0
All Linux
medium Severity medium
: rc
: ---
Assigned To: Panu Matilainen
BaseOS QE Security Team
:
Depends On:
Blocks: 582655
  Show dependency treegraph
 
Reported: 2010-06-28 05:34 EDT by Jiri Kastner
Modified: 2011-05-19 10:19 EDT (History)
2 users (show)

See Also:
Fixed In Version: rpm-4.8.0-14.el6
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2011-05-19 10:19:39 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)


External Trackers
Tracker ID Priority Status Summary Last Updated
Red Hat Product Errata RHBA-2011:0739 normal SHIPPED_LIVE rpm bug fix and enhancement update 2012-10-23 15:19:10 EDT

  None (edit)
Description Jiri Kastner 2010-06-28 05:34:58 EDT
Description of problem:


Version-Release number of selected component (if applicable):


How reproducible:
always

Steps to Reproduce:
1. sign package with SHA384
2. sign package with SHA512 with same key as above
3. run rpm -v --checksig some.rpm
4. check output
  
Actual results:
####################################################################
[user@somewhere ~]$ rpm -v --delsign mod_gnutls-0.5.6-1.md5.x86_64.rpm 
mod_gnutls-0.5.6-1.md5.x86_64.rpm:
[user@somewhere ~]$ rpm -v --checksig mod_gnutls-0.5.6-1.md5.x86_64.rpm 
mod_gnutls-0.5.6-1.md5.x86_64.rpm:
    Header SHA1 digest: OK (2a30e68848f8aa15028e160164ce309c26b6f735)
    MD5 digest: OK (7b86a7c836b21679133b77ff7cdce95b)
[user@somewhere ~]$ rpm -v --addsign mod_gnutls-0.5.6-1.md5.x86_64.rpm 
Enter pass phrase: 
Pass phrase is good.
mod_gnutls-0.5.6-1.md5.x86_64.rpm:
[user@somewhere ~]$ rpm -v --checksig mod_gnutls-0.5.6-1.md5.x86_64.rpm 
mod_gnutls-0.5.6-1.md5.x86_64.rpm:
    Header V3 RSA/SHA384 Signature, key ID c842f47e: OK
    Header SHA1 digest: OK (2a30e68848f8aa15028e160164ce309c26b6f735)
    V3 RSA/SHA384 Signature, key ID c842f47e: OK
    MD5 digest: OK (7b86a7c836b21679133b77ff7cdce95b)
[user@somewhere ~]$ rpm -v --addsign mod_gnutls-0.5.6-1.md5.x86_64.rpm 
Enter pass phrase: 
Pass phrase is good.
mod_gnutls-0.5.6-1.md5.x86_64.rpm:
[user@somewhere ~]$ rpm -v --checksig mod_gnutls-0.5.6-1.md5.x86_64.rpm 
mod_gnutls-0.5.6-1.md5.x86_64.rpm:
    Header V3 RSA/SHA512 Signature, key ID c842f47e: OK
    Header SHA1 digest: OK (2a30e68848f8aa15028e160164ce309c26b6f735)
    V3 RSA/SHA384 Signature, key ID c842f47e: BAD
    V3 RSA/SHA512 Signature, key ID c842f47e: OK
    MD5 digest: OK (7b86a7c836b21679133b77ff7cdce95b)


Expected results:
[user@somewhere ~]$ rpm -v --checksig mod_gnutls-0.5.6-1.md5.x86_64.rpm 
mod_gnutls-0.5.6-1.md5.x86_64.rpm:
    Header V3 RSA/SHA512 Signature, key ID c842f47e: OK
    Header SHA1 digest: OK (2a30e68848f8aa15028e160164ce309c26b6f735)
    V3 RSA/SHA384 Signature, key ID c842f47e: OK
    V3 RSA/SHA512 Signature, key ID c842f47e: OK
    MD5 digest: OK (7b86a7c836b21679133b77ff7cdce95b)

Additional info:
Comment 1 Jiri Kastner 2010-06-28 05:37:10 EDT
also switching to DSA/SHA1 key/algo shows all RSA signatures as BAD
Comment 2 RHEL Product and Program Management 2010-06-28 05:42:53 EDT
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux major release.  Product Management has requested further
review of this request by Red Hat Engineering, for potential inclusion in a Red
Hat Enterprise Linux Major release.  This request is not yet committed for
inclusion.
Comment 3 RHEL Product and Program Management 2010-07-15 11:01:32 EDT
This issue has been proposed when we are only considering blocker
issues in the current Red Hat Enterprise Linux release. It has
been denied for the current Red Hat Enterprise Linux release.

** If you would still like this issue considered for the current
release, ask your support representative to file as a blocker on
your behalf. Otherwise ask that it be considered for the next
Red Hat Enterprise Linux release. **
Comment 12 errata-xmlrpc 2011-05-19 10:19:39 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2011-0739.html

Note You need to log in before you can comment on or make changes to this bug.